/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package scrollpanetestapp;

import java.util.function.Supplier;
import java.util.stream.Stream;
import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.ScrollPane;
import javafx.scene.control.Slider;
import javafx.scene.layout.HBox;
import javafx.scene.layout.Pane;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.stage.Stage;

/**
 *
 * @author dginzburg
 */
public class ScrollPaneTestApp extends Application {
    
    @Override
    public void start(Stage primaryStage) {
        Rectangle rect = new Rectangle(200, 200, Color.RED);
        
        ScrollPane scrollPane = new ScrollPane(rect);
        scrollPane.setStyle("-fx-background-color: blue;");
        
        Node[] sliders = Stream.of(
                scrollPane.prefViewportHeightProperty(), scrollPane.prefViewportWidthProperty(),
                scrollPane.minViewportHeightProperty(), scrollPane.minViewportWidthProperty())
                .map(property -> {
                    Label label = new Label(property.getName());
                    Slider slider = new Slider(0, 100, 0);
                    slider.valueProperty().bindBidirectional(property);
                    HBox sliderBox = new HBox(label, slider);
                    return sliderBox;
                })
                .toArray(Node[]::new);
        
        Pane slidersPane = new VBox(sliders);
        
        Pane root = new HBox(scrollPane, slidersPane);
        
        Scene scene = new Scene(root, 300, 250);
        
        primaryStage.setTitle("Hello World!");
        primaryStage.setScene(scene);
        primaryStage.show();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }
    
}
